<?php

class ControllerPaymentPagoEfectivoCip extends Controller {

    private $error = array();

    public function index() {

        $this->load->language('payment/pago_efectivo_cip');

        $this->document->setTitle('PagoEfectivo Payment Method Configuration');

        $this->load->model('setting/setting');

        $token = 'token=' . $this->session->data['token'];

        $ds = DIRECTORY_SEPARATOR;

        $path_conciliacion = DIR_CATALOG."pagoefectivo".$ds."conciliacion";

        if (!file_exists($path_conciliacion)) {

            if (!mkdir($path_conciliacion, 0777, true)) {

                die('Failed to create folders...');

            }

        }

        if (($this->request->server['REQUEST_METHOD'] == 'POST')) {

            $this->load->model('user/api');

            $api_info = $this->model_user_api->getApi($this->config->get('config_api_id'));

            $username = $api_info['username'];

            $password = $api_info['password'];

            $OPCION = $_POST['submit'];

            try {

                $utilities_directory = DIR_CATALOG.'utilities'.$ds;

                require_once($utilities_directory.'lib_pagoefectivo/configpe.php');
                require_once($utilities_directory.'lib_pagoefectivo/PagoEfectivo.php');
                require_once($utilities_directory.'lib_pagoefectivo/be/be_solicitud.php');

                //require_once(DIR_CATALOG.'model/checkout/order.php');

                require_once('opencart.php');

                $oc = new OpenCart\OpenCart(HTTP_CATALOG, 'cookiejar');

                //$catalogCheckoutModel = new ModelCheckoutOrder($this->registry);

                $pagoefectivo = new App_Service_PagoEfectivo();

                $this->load->model('sale/order');

                $this->load->model('localisation/order_status');

                $arr_estado = array('22'=> 'Pendiente', '23'=>'Pagado', '21'=>'Expirado', '25'=>'Eliminado');

                if ($OPCION == "Actualizar") {

                    $CIP = $_POST['numeros_cip'];

                    $paymentResponse =$pagoefectivo->consultarCIP(trim($CIP));

                    if($paymentResponse->Estado){

                        $CIPResult = $paymentResponse->CIPs->ConfirSolPago;

                        $mensaje = '';

                        foreach($CIPResult as $CIPs){

                            $orderId = $CIPs->CIP->OrderIdComercio;
                            $order_info = $this->model_sale_order->getOrder($orderId);
                            $order_status_id = $order_info['order_status_id'];
                            $order_status_name = $this->model_localisation_order_status->getOrderStatus($order_status_id);

                            $mensaje .= 'Número de CIP: '.$CIPs->CIP->IdOrdenPago.'<br />';
                            $mensaje .= 'Número de pedido: '.$CIPs->CIP->OrderIdComercio.'<br />';
                            $mensaje .= 'Estado actual del pedido: <b>'.$order_status_name['name'].'</b><br />';
                            $mensaje .= 'Estado del CIP: <b>'.$arr_estado[(string)($CIPs->CIP->IdEstado)].'</b><br />';
                            $mensaje .= 'Fecha de Emision: '.$CIPs->CIP->FechaEmision.'<br />';

                            switch ($CIPs->CIP->IdEstado) {
                                case 21:
                                    if($order_status_id == 1){
                                        $order_status_id = '7';
                                        $notify = false;
                                        $append = true;
                                        $comment = 'Se cambio la orden a Expirado en PE y a Cancelado en OC por que el CIP expiró en PE.';
                                        if ($oc->login($username, $password)) {
                                            $oc->order->history($orderId, $order_status_id, $notify, $append, $comment);
                                        } else {
                                            echo $oc->getLastError();
                                        }
                                    }
                                    if($order_status_id == 2){
                                        $order_status_id = '7';
                                        $notify = false;
                                        $append = true;
                                        $comment = 'Se cambio la orden a Expirado en PE y a Cancelado en OC por que el CIP expiró en PE. Pero, el estado de la orden estaba en procesando. Verificar este caso.';
                                        if ($oc->login($username, $password)) {
                                            $oc->order->history($orderId, $order_status_id, $notify, $append, $comment);
                                        } else {
                                            echo $oc->getLastError();
                                        }
                                    }
                                    break;

                                case 22:
                                    $order_status_id = '1';
                                    $notify = false;
                                    $append = true;
                                    $comment = 'El CIP aún esta pendiente de pago.';

                                    if ($oc->login($username, $password)) {
                                        $oc->order->history($orderId, $order_status_id, $notify, $append, $comment);
                                    } else {
                                        echo $oc->getLastError();
                                    }

                                    break;

                                case 23:
                                    $order_status_id = '2';
                                    $notify = false;
                                    $append = true;
                                    $comment = 'El CIP ha sido pagado.';

                                    if ($oc->login($username, $password)) {
                                        $oc->order->history($orderId, $order_status_id, $notify, $append, $comment);
                                    } else {
                                        echo $oc->getLastError();
                                    }

                                    break;

                                case 25:
                                    $order_status_id = '7';
                                    $notify = false;
                                    $append = true;
                                    $comment = 'El CIP ha sido eliminado.';

                                    if ($oc->login($username, $password)) {
                                        $oc->order->history($orderId, $order_status_id, $notify, $append, $comment);
                                    } else {
                                        echo $oc->getLastError();
                                    }

                                    break;

                                default:
                                    echo 'Estado: ERROR';
                                    return;
                            }
                            $order_info = $this->model_sale_order->getOrder($orderId);
                            $order_status_id = $order_info['order_status_id'];
                            $order_status_name = $this->model_localisation_order_status->getOrderStatus($order_status_id);
                            $mensaje .= 'Nuevo estado del pedido: <b>'.$order_status_name['name'].'</b>';
                            $mensaje .= '<br><br>';

                        }

                    }else{

                        $mensaje = $paymentResponse->ConsultarCIPResult->Mensaje;

                    }

                    $data['mensaje_actualizar'] = $mensaje;

                }

                if ($OPCION == "Eliminar") {

                    $CIP = $_POST['numeros_cip'];

                    $CIPLista = explode(',', $CIP);

                    $mensaje = '';

                    foreach($CIPLista as $CIPs){

                        $paymentRequest = $pagoefectivo->eliminarCip($CIPs);
                        $mensaje .= $paymentRequest->Mensaje.'<br /><br />';
                        $estado = $paymentRequest->Estado;

                        if ($estado == 1) {

                            $paymentResponse = $pagoefectivo->consultarCIP($CIPs);

                            $CIPResult = $paymentResponse->CIPs->ConfirSolPago;
                            $CIPResult = $CIPResult->CIP;

                            $order_id = $CIPResult->OrderIdComercio;

                            $order_info = $this->model_sale_order->getOrder($order_id);
                            $order_status_id = $order_info['order_status_id'];
                            $order_status_name = $this->model_localisation_order_status->getOrderStatus($order_status_id);

                            $mensaje .= 'Número de pedido: '.$order_id.'<br />';
                            $mensaje .= 'Estado actual del pedido: <b>'.$order_status_name['name'].'</b><br />';
                            $mensaje .= 'Estado del CIP: <b>'.$arr_estado[(string)$CIPResult->IdEstado].'</b><br />';
                            $mensaje .= 'Fecha de Emision: '.$CIPResult->FechaEmision.'<br />';

                            $order_status_id = '7';
                            $notify = false;
                            $append = true;
                            $comment = 'Nuevo estado del CIP: '.$arr_estado[(string)$CIPResult->IdEstado];

                            if ($oc->login($username, $password)) {
                                $oc->order->history($order_id, $order_status_id, $notify, $append, $comment);
                            } else {
                                echo $oc->getLastError();
                            }

                            $order_info = $this->model_sale_order->getOrder($order_id);
                            $order_status_id = $order_info['order_status_id'];
                            $order_status_name = $this->model_localisation_order_status->getOrderStatus($order_status_id);

                            $mensaje .= 'Nuevo estado del pedido: <b>'.$order_status_name['name'].'</b>';
                            $mensaje .= '<br><br><br>';

                        }

                    }

                    $data['mensaje_eliminar'] = $mensaje;

                }

                if ($OPCION == "Actualizar Fecha") {

                    $CIP = $_POST['numeros_cip'];

                    $FECHA = $_POST['fecha'];

                    $mensaje = '';

                    $CIPLista = explode(',', $CIP);

                    foreach($CIPLista as $CIPs){
                        $paymentResponse =$pagoefectivo->actualizarCip($CIPs, trim($FECHA));
                        $mensaje .= $paymentResponse->Mensaje;
                        $mensaje .= '<br><br>';
                    }

                    $data['mensaje_actualizar_fecha'] = $mensaje;

                }

                // if ($OPCION == "Conciliar") { 

                //     $pe_file_text = $this->request->files;

                //     if ($pe_file_text['archivo_conciliacion']['type'] == "text/plain") {

                //         if (isset($pe_file_text)){

                //             if($pe_file_text['archivo_conciliacion']['error'] == "0"){

                //                 $pago_efectivo_cip_text = $path_conciliacion.$ds.$pe_file_text['archivo_conciliacion']['name'];
                //                 move_uploaded_file($pe_file_text['archivo_conciliacion']['tmp_name'], $pago_efectivo_cip_text);
                //                 $nombre_archivo = $pe_file_text['archivo_conciliacion']['name'];

                //                 $mensaje = '';
                //                 $mensaje .= 'Nombre del archivo: '.$nombre_archivo.'<br/>';

                //                 /*$mensaje .= "<hr>";*/

                //                 /*$CO_EMP = substr($nombre_archivo,6,3);
                //                 $CO_SER = substr($nombre_archivo,10,3);*/

                //                 /*$mensaje .= "El codigo de empresa es: ".$CO_EMP."<br />";
                //                 $mensaje .= "El codigo de servicio es: ".$CO_SER."<br />";
                //                 $mensaje .= "<hr>";*/

                //                 $fp = fopen($pago_efectivo_cip_text, "r");
                //                 while(!feof($fp)) {
                //                     $data[] = fgets($fp);
                //                 }
                //                 fclose($fp);

                //                 /*$mensaje .= "El contenido de la primera linea es: ".$data[0]."<br />";*/

                //                 $nombre_servicio = substr($data[0],0,50);
                //                 $cantidad_registros = (int)substr($data[0],50,10);
                //                 $fecha_dia = substr($data[0],60,2);
                //                 $fecha_mes = substr($data[0],62,2);
                //                 $fecha_anio = substr($data[0],64,4);
                //                 $fecha = $fecha_dia.'/'.$fecha_mes.'/'.$fecha_anio;

                //                 $mensaje .= "Nombre de servicio: ".$nombre_servicio."<br />";
                //                 $mensaje .= "Cantidad de registros: ".(int)$cantidad_registros."<br />";
                //                 $mensaje .= "Fecha: ".$fecha."<br />";
                //                 $mensaje .= "<br /><hr>";

                //                 $mensaje .= "<table class='pe-tabla'>";
                //                 $mensaje .= "<thead>";
                //                 $mensaje .= "<tr>";
                //                 $mensaje .= "<th>Número de CIP</th>";
                //                 $mensaje .= "<th>Número de pedido</th>";
                //                 $mensaje .= "<th>Fecha de creación</th>";
                //                 $mensaje .= "<th>Fecha de pago</th>";
                //                 $mensaje .= "<th>Lugar de pago</th>";
                //                 $mensaje .= "<th>Total pagado</th>";
                //                 $mensaje .= "<th>Moneda</th>";
                //                 $mensaje .= "<th>Estado</th>";
                //                 $mensaje .= "</tr>";
                //                 $mensaje .= "</thead>";
                //                 $mensaje .= "<tbody>";
                //                 /*$fecha = substr($data[0],60,8);*/

                //                 /*$mensaje .= "El nombre de servicio es: ".$nombre_servicio."<br />";
                //                 $mensaje .= "La cantidad de registros es: ".(int)$cantidad_registros."<br />";
                //                 $mensaje .= "La fecha es: ".$fecha."<br />";
                //                 $mensaje .= "<hr>";*/

                //                 for ($i = 1; $i <= $cantidad_registros; $i++) {
                                    
                //                     $cip = ltrim(substr($data[$i],0,14),"0");

                //                     $paymentResponse =$pagoefectivo->consultarCIP(trim($cip));
                //                     $CIPResult = $paymentResponse->CIPs->ConfirSolPago;
                //                     $order_id = $CIPResult->CIP->OrderIdComercio;

                //                     $order_info = $this->model_sale_order->getOrder($order_id);
                //                     $order_status_id = $order_info['order_status_id'];
                //                     $order_status_name = $this->model_localisation_order_status->getOrderStatus($order_status_id);

                //                     $fecha_creacion_dia = substr($data[$i],14,2);
                //                     $fecha_creacion_mes = substr($data[$i],16,2);
                //                     $fecha_creacion_anio = substr($data[$i],18,4);
                //                     $fecha_creacion = $fecha_creacion_dia.'/'.$fecha_creacion_mes.'/'.$fecha_creacion_anio;

                //                     $fecha_pago_dia = substr($data[$i],22,2);
                //                     $fecha_pago_mes = substr($data[$i],24,2);
                //                     $fecha_pago_anio = substr($data[$i],26,4);
                //                     $fecha_pago = $fecha_pago_dia.'/'.$fecha_pago_mes.'/'.$fecha_pago_anio;

                //                     $banco_codigo = substr($data[$i],30,3);

                //                     switch ($banco_codigo) {
                //                         case 002:
                //                           $banco = "BCP";
                //                           break;
                //                         case 003:
                //                           $banco = "BBVA Continental";
                //                           break;
                //                         case 004:
                //                           $banco = "Interbank";
                //                           break;
                //                         case 005:
                //                           $banco = "Scotiabank";
                //                           break;
                //                         case 006:
                //                           $banco = "Western Union";
                //                           break;
                //                         case 007:
                //                           $banco = "Banbif";
                //                           break;
                //                         case 100:
                //                           $banco = "Centros Full Carga";
                //                           break;
                //                     }

                //                     $orden_compra = ltrim(substr($data[$i],33,18),"0");
                //                     $total = ltrim(substr($data[$i],51,16),"0").".".substr($data[$i],67,2);

                //                     $moneda_codigo = substr($data[$i],69,3);
                //                     switch ($moneda_codigo) {
                //                       case 604:
                //                           $moneda = "Soles";
                //                           break;
                //                       case 840:
                //                           $moneda = "Dólares";
                //                           break;
                //                     }
                //                     /*$fecha_creacion = substr($data[$i],14,8);
                //                     $fecha_pago = substr($data[$i],22,8);
                //                     $banco = substr($data[$i],30,3);*/

                //                     /*$orden_compra = ltrim(substr($data[$i],33,18),"0");*/
                                    
                //                     /*$total = ltrim(substr($data[$i],51,16),"0")."@".substr($data[$i],67,2);
                //                     $moneda = substr($data[$i],69,3);
                //                     $mensaje .= "El contenido del contenido ". $i ."es: ".$data[$i]."<br />";
                //                     $mensaje .= "El numero de cip es: ".$cip."<br />";
                //                     $mensaje .= "La fecha de creacion es: ".$fecha_creacion."<br />";
                //                     $mensaje .= "La fecha de pago es: ".$fecha_pago."<br />";
                //                     $mensaje .= "El banco es: ".$banco."<br />";
                //                     $mensaje .= "La orden de compra es: ".$orden_compra."<br />";
                //                     $mensaje .= "El total es: ".$total."<br />";
                //                     $mensaje .= "La moneda es: ".$moneda."<br />";
                //                     $mensaje .= "<hr>";*/

                //                     $mensaje .= "<tr>";
                //                     $mensaje .= "<td>".$cip."</td>";
                //                     $mensaje .= "<td>".$orden_compra."</td>";
                //                     $mensaje .= "<td>".$fecha_creacion."</td>";
                //                     $mensaje .= "<td>".$fecha_pago."</td>";
                //                     $mensaje .= "<td>".$banco."</td>";
                //                     $mensaje .= "<td>".$total."</td>";
                //                     $mensaje .= "<td>".$moneda."</td>";
                //                     if (isset($order_status_name['name'])){
                //                         if ($order_status_name['name'] != "Processingg"){
                //                         $mensaje .= "<td  bgcolor='#F24747'>".$order_status_name['name']."</td>";
                //                         } else {
                //                         $mensaje .= "<td  bgcolor='#47F24F'>".$order_status_name['name']."</td>";
                //                         }
                //                     }else{
                //                         $mensaje .= "<td bgcolor='#F24747'></td>";
                //                     }
                //                     $mensaje .= "</tr>";

                //                 }

                //                 $mensaje .= "</tbody>";
                //                 $mensaje .= "</table>";

                //             }

                //         }

                //     }else{

                //         $mensaje = "Archivo de texto no compatible. Suba archivos de formato .txt";

                //     }

                //     $data['accion'] = 'conciliar';

                //     $data['mensaje_conciliar'] = $mensaje;
                // }

            }
            catch (Exception $e){
                var_dump($e);
                echo 'Mensaje: ',  $e->getMessage(), "\n";
            }

        }    

        // $links_map = array('text_home' => 'common/dashboard',
        // 'text_payment' => 'extension/payment',
        // 'heading_title' => 'payment/pago_efectivo_cip');

        // $data['breadcrumbs'] = array();

        $labels = array('text_home', 'text_form', 'text_payment', 'heading_title', 'heading_title_1', 'heading_title_2', 'heading_title_3', 'heading_title_4', 'content_title_1', 'content_title_2', 'content_title_3', 'content_title_3_2', 'content_title_4', 'input_value_1', 'input_value_2', 'input_value_3', 'input_value_4', 'content_mensaje_1', 'content_mensaje_2', 'content_mensaje_3', 'text_button_save', 'text_button_cancel');

        foreach ($labels as $value) {
            $data[$value] = $this->language->get($value);
        }

        $url = '';

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_payment'),
            'href' => $this->url->link('extension/payment', 'token=' . $this->session->data['token'] . $url, 'SSL')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('payment/pago_efectivo_cip', 'token=' . $this->session->data['token'] . $url, 'SSL')
        );

        $data['action'] = $this->url->link('payment/pago_efectivo_cip', $token, 'SSL');

        $data['cancel'] = $this->url->link('extension/payment', $token, 'SSL');

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('payment/pago_efectivo_cip.tpl', $data));
    }

}