<?php
class ControllerCheckoutPagoEfectivoSuccess extends Controller {

    public function index() {

        if (isset($this->session->data['order_id'])) {
            $this->cart->clear();

            unset($this->session->data['shipping_method']);
            unset($this->session->data['shipping_methods']);
            unset($this->session->data['payment_method']);
            unset($this->session->data['payment_methods']);
            unset($this->session->data['guest']);
            unset($this->session->data['comment']);
            unset($this->session->data['order_id']);    
            unset($this->session->data['coupon']);
            unset($this->session->data['reward']);
            unset($this->session->data['voucher']);
            unset($this->session->data['vouchers']);
        }

        $this->load->language('checkout/success');

        $get = $this->request->get;
        
        $data['token'] = $get['token'];

        $data['integration'] = $this->config->get('pago_efectivo_integration_mode');

        $data['url_servidor'] = $this->config->get('pago_efectivo_pagoefectivo_url_server');

        $this->document->setTitle($this->language->get('heading_title'));

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
                'text' => $this->language->get('text_home'),
                'href' => $this->url->link('common/home')
        );

        $data['breadcrumbs'][] = array(
                'text' => $this->language->get('text_basket'),
                'href' => $this->url->link('checkout/cart')
        );

        $data['breadcrumbs'][] = array(
                'text' => $this->language->get('text_checkout'),
                'href' => $this->url->link('checkout/checkout', '', 'SSL')
        );

        $data['breadcrumbs'][] = array(
                'text' => $this->language->get('text_success'),
                'href' => $this->url->link('checkout/success')
        );

        $data['heading_title'] = $this->language->get('heading_title');

        if ($this->customer->isLogged()) {
                $data['text_message'] = sprintf($this->language->get('text_customer'), $this->url->link('account/account', '', 'SSL'), $this->url->link('account/order', '', 'SSL'), $this->url->link('account/download', '', 'SSL'), $this->url->link('information/contact'));
        } else {
                $data['text_message'] = sprintf($this->language->get('text_guest'), $this->url->link('information/contact'));
        }

        $data['button_continue'] = $this->language->get('button_continue');

        $data['continue'] = $this->url->link('common/home');

        $data['column_left'] = $this->load->controller('common/column_left');
        $data['column_right'] = $this->load->controller('common/column_right');
        $data['content_top'] = $this->load->controller('common/content_top');
        $data['content_bottom'] = $this->load->controller('common/content_bottom');
        $data['footer'] = $this->load->controller('common/footer');
        $data['header'] = $this->load->controller('common/header');

        if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/common/pago_efectivo_success.tpl')) {
            $this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/common/pago_efectivo_success.tpl', $data));
        } else {
            $this->response->setOutput($this->load->view('default/template/common/pago_efectivo_success.tpl', $data));
        }

    }

    public function notification() {

        $ds = DIRECTORY_SEPARATOR;

        $utilities_directory = DIR_APPLICATION.'utilities'.$ds;

        ini_set('display_errors',1);

        $flag = true;

        if ($flag) {

            require_once($utilities_directory.'lib_pagoefectivo/PagoEfectivo.php');

            require_once($utilities_directory.'lib_pagoefectivo/be/be_notificacion.php');

            $pagoefectivo = new App_Service_PagoEfectivo();

            $estado = new BE_Notificacion();

            $data = $_GET['data'];

            $paymentResponse = simplexml_load_string($pagoefectivo->desencriptarData($data));

            if($paymentResponse!=null){

                $this->load->model('checkout/order');

                $order_id = $paymentResponse->CodTrans;

                $order_info = $this->model_checkout_order->getOrder($order_id);
                
                switch ($paymentResponse->Estado) {

                    case $estado->Extornado:

                        $comment = "PagoEfectivo extornó el pago.";
                        $this->model_checkout_order->addOrderHistory($order_id,1,$comment,true);

                        break;

                    case $estado->Pagado:

                        $comment = "PagoEfectivo autorizó el pago.";

                        $this->model_checkout_order->addOrderHistory($order_id,2,$comment,true);

                        break;

                    case $estado->Expirado:

                        $comment = "El número de CIP ha expirado.";

                        $this->model_checkout_order->addOrderHistory($order_id,7,$comment,true);

                        break;
                        
                    default: echo 'Estado: ERROR';
                        http_response_code(400);
                        header( "HTTP/1.1 400 Bad Request");
                        exit;
                }

            }else{
                echo 'Estado: ERROR CONEXIÓN WEB SERVICE';
                http_response_code(401);
                header( "HTTP/1.1 401 ERROR CONEXIÓN WEB SERVICE");
            }
       }else{
            echo 'Estado: ERROR PARAMETROS';
            http_response_code(402);
            header( "HTTP/1.1 402 ERROR PARAMETROS");
       }
       exit;
    }
}