<?php
class ControllerPaymentPagoEfectivo extends Controller {

    public function index() {

        $this->load->language('payment/pago_efectivo');

        $labels = array('text_title', 'text_terms', 'text_instruction', 'text_payment', 'text_payable', 'text_instruction_link', 'button_confirm');

        foreach ($labels as $value) {

            $data[$value] = $this->language->get($value);
            
        }

        $this->load->model('setting/setting');

        $fields = array('title_desc_banc', 'title_desc_agent', 'content_question', 'url_question');

        foreach ($fields as $value) {

            $attribute = 'pago_efectivo_' . $value;
            $data[$attribute] = $this->config->get($attribute);

        }

        $data['continue'] = $this->url->link('checkout/pago_efectivo_success');

        $data['order_id'] = $this->session->data['order_id'];

        $this->load->model('checkout/order');

        if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/pago_efectivo.tpl')) {

            return $this->load->view($this->config->get('config_template') . '/template/payment/pago_efectivo.tpl', $data);

        } else {

            return $this->load->view('default/template/payment/pago_efectivo.tpl', $data);

        }
        
    }

    public function confirm() {
            
        if ($this->session->data['payment_method']['code'] == 'pago_efectivo') {

            $this->load->language('payment/pago_efectivo');

            $this->load->model('checkout/order');

            $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
                
            if($order_info['currency_code'] == 'USD'){

                $pe_currency_code = 2;

            }else{

                $pe_currency_code = 1;

            }
                
            $ds = DIRECTORY_SEPARATOR;

            $utilities_directory = DIR_APPLICATION.'utilities'.$ds;

            $currency_total = $order_info['total']*$order_info['currency_value'];
            
            require_once($utilities_directory.'lib_pagoefectivo/PagoEfectivo.php');

            require_once($utilities_directory.'lib_pagoefectivo/be/be_solicitud.php');

            date_default_timezone_set('America/Lima');

            $paymentRequest = new BEGenRequest();
            $paymentRequest->_moneda            = $pe_currency_code;
            $paymentRequest->_monto             = number_format($currency_total, 2, '.', '');
            $paymentRequest->_medio_pago        = PE_MEDIO_PAGO;
            $paymentRequest->_cod_servicio      = PE_MERCHAND_ID;
            $paymentRequest->_numero_orden      = $order_info['order_id'];
            $paymentRequest->_concepto_pago     = substr(PE_COMERCIO_CONCEPTO_PAGO,0,16);
            $paymentRequest->_email_comercio    = PE_EMAIL_PORTAL;
            $paymentRequest->_fecha_expirar     = date('d/m/Y H:i:s', time() + ((int)PE_TIEMPO_EXPIRACION_DIA * 24 * 60 * 60) + ((int)PE_TIEMPO_EXPIRACION_HORA * 60 * 60) + ((int)PE_TIEMPO_EXPIRACION_MINUTO * 60));
            $paymentRequest->_usuario_nombre    = substr(especiales($order_info['payment_firstname']),0,10);
            $paymentRequest->_usuario_apellidos = substr(especiales($order_info['payment_lastname']),0,10);
            $paymentRequest->_usuario_email     = $order_info['email'];
            $paymentRequest->_usuario_domicilio = substr(especiales($order_info['payment_address_1']),0,16);

            $pagoefectivo = new App_Service_PagoEfectivo();
            
            $paymentResponse = $pagoefectivo->GenerarCip($paymentRequest);

            $token = $paymentResponse->Token;

            $cip = $paymentResponse->CIP->NumeroOrdenPago;

            $iframe = PE_WSGENPAGOIFRAME . '?Token='. $token;

            $redirect = PE_WSGENPAGO . '?Token='. $token;

            $comment  = "CIP : <a href='$iframe' target='_blank'>$cip</a> " . "\n";

            $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], $this->config->get('pago_efectivo_order_status_id'), $comment, true);

            $json_data = array('token' => "$token", 'cip' => "$cip");

            $this->response->setOutput(json_encode($json_data));

        }
                
    }
        
}

function especiales($s)
{  
    $s = preg_replace("/á|à|â|ã|ª/","a",$s);
    $s = preg_replace("/Á|À|Â|Ã/","A",$s);
    $s = preg_replace("/é|è|ê/","e",$s);
    $s = preg_replace("/É|È|Ê/","E",$s);
    $s = preg_replace("/í|ì|î/","i",$s);
    $s = preg_replace("/Í|Ì|Î/","I",$s);
    $s = preg_replace("/ó|ò|ô|õ|º/","o",$s);
    $s = preg_replace("/Ó|Ò|Ô|Õ/","O",$s);
    $s = preg_replace("/ú|ù|û/","u",$s);
    $s = preg_replace("/Ú|Ù|Û/","U",$s);
    $s = str_replace("ñ","n",$s);
    $s = str_replace("Ñ","N",$s);
    $s = trim(preg_replace('/[^a-zA-Z0-9., ]/','',$s));
    return $s;     
}